<template>
  <form @submit.prevent="submitForm">
    <div class="form-group" :class="{invalid: !firstname.isValid}">
      <label for="firstname">Prénom</label>
      <input
          class="form-control"
        type="text"
        id="firstname"
        v-model.trim="firstname.val"
        @blur="clearValidity('firstname')"
      />
      <p v-if="!firstname.isValid">Firstname must not be empty.</p>
    </div>
    <div class="form-group" :class="{invalid: !lastname.isValid}">
      <label for="lastname">Nom</label>
      <input
          class="form-control"
        type="text"
        id="lastname"
        v-model.trim="lastname.val"
        @blur="clearValidity('lastname')"
      />
      <p v-if="!lastname.isValid">Lastname must not be empty.</p>
    </div>
    <div class="form-group" :class="{invalid: !email.isValid}">
      <label for="email">Email</label>
      <input type="text" class="form-control" id="email" rows="5" v-model.trim="email.val" @blur="clearValidity('email')">
      <p v-if="!email.isValid">Email must not be empty.</p>
    </div>
    <div class="form-group" :class="{invalid: !username.isValid}">
      <label for="username">Nom Utilisateur</label>
      <input class="form-control" type="text" id="username" v-model.trim="username.val" @blur="clearValidity('username')" />
      <p v-if="!username.isValid">Username must not be empty.</p>
    </div>
      <div class="form-group" :class="{invalid: !localisation.isValid}">
        <label for="localisation">Localisation</label>
        <input class="form-control" type="text" id="localisation" v-model.trim="localisation.val" @blur="clearValidity('localisation')" />
        <p v-if="!localisation.isValid">localisation must not be empty.</p>
    </div>

    <p v-if="!formIsValid">Please fix the above errors and submit again.</p>
    <base-button>Register</base-button>
  </form>
</template>

<script>
export default {
  emits: ['save-data'],
  data() {
    return {
      firstname: {
        val: '',
        isValid: true,
      },
      lastname: {
        val: '',
        isValid: true,
      },
      email: {
        val: '',
        isValid: true,
      },
      username: {
        val: '',
        isValid: true,
      },
      localisation: {
        val: '',
        isValid: true,
      },

      formIsValid: true,
    };
  },
  methods: {
    clearValidity(input) {
      this[input].isValid = true;
    },
    validateForm() {
      this.formIsValid = true;
      if (this.firstname.val === '') {
        this.firstname.isValid = false;
        this.formIsValid = false;
      }
      if (this.lastname.val === '') {
        this.lastname.isValid = false;
        this.formIsValid = false;
      }
      if (this.email.val === '') {
        this.email.isValid = false;
        this.formIsValid = false;
      }
      if (!this.username.val === '') {
        this.username.isValid = false;
        this.formIsValid = false;
      }
      if (this.localisation.val === '') {
        this.localisation.isValid = false;
        this.formIsValid = false;
      }
    },
    submitForm() {
      this.validateForm();

      if (!this.formIsValid) {
        return;
      }

      const formData = {
        firstname: this.firstname.val,
        lastname: this.lastname.val,
        email: this.email.val,
        username: this.username.val,
        localisation: this.localisation.val,
      };

      this.$emit('save-data', formData);
    },
  },
};
</script>

<style scoped>

</style>